"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantSetStats(ProtocolElement):
    """
    Variant statistics for a set of variants.      The variants set can be
    contain a whole study, a cohort, a sample, a region, ...
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "meanQuality",
        "numPass",
        "numSamples",
        "numVariants",
        "stdDevQuality",
        "tiTvRatio",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import opencb as opencb_1_3_0

        return {
            "chromosomeStats": opencb_1_3_0.ChromosomeStats,
            "numRareVariants": opencb_1_3_0.VariantsByFrequency,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.metadata.ChromosomeStats": opencb_1_3_0.ChromosomeStats,
            "org.opencb.biodata.models.variant.metadata.VariantsByFrequency": opencb_1_3_0.VariantsByFrequency,
            "org.opencb.biodata.models.variant.metadata.VariantSetStats": opencb_1_3_0.VariantSetStats,
        }

    __slots__ = [
        "meanQuality",
        "numPass",
        "numSamples",
        "numVariants",
        "stdDevQuality",
        "tiTvRatio",
        "chromosomeStats",
        "consequenceTypesCounts",
        "numRareVariants",
        "variantBiotypeCounts",
        "variantTypeCounts",
    ]

    def __init__(
        self,
        meanQuality,
        numPass,
        numSamples,
        numVariants,
        stdDevQuality,
        tiTvRatio,
        chromosomeStats=dict,
        consequenceTypesCounts=dict,
        numRareVariants=list,
        variantBiotypeCounts=dict,
        variantTypeCounts=dict,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantSetStats model.

        :param meanQuality:
            Mean Quality for all the variants with quality
        :type meanQuality: float
        :param numPass:
            Number of variants with PASS filter
        :type numPass: int
        :param numSamples:
            Number of samples in the variants set
        :type numSamples: int
        :param numVariants:
            Number of variants in the variants set
        :type numVariants: int
        :param stdDevQuality:
            Standard Deviation of the quality
        :type stdDevQuality: float
        :param tiTvRatio:
            TiTvRatio = num. transitions / num. transversions
        :type tiTvRatio: float
        :param chromosomeStats:
            Statistics per chromosome.
        :type chromosomeStats: dict[str, ChromosomeStats]
        :param consequenceTypesCounts:
            Variants count group by consequence type. e.g. synonymous_variant,
            missense_variant, stop_lost, ...
        :type consequenceTypesCounts: dict[str, int]
        :param numRareVariants:
            array of elements to classify variants according to their 'rarity'
            Typical frequency ranges:           - very rare     ->
            from 0 to 0.001           - rare          -> from 0.001 to
            0.005           - low frequency -> from 0.005 to 0.05
            - common        -> from 0.05
        :type numRareVariants: list[VariantsByFrequency]
        :param variantBiotypeCounts:
            Variants count group by biotype. e.g. protein-coding, miRNA, lncRNA,
            ...
        :type variantBiotypeCounts: dict[str, int]
        :param variantTypeCounts:
            Variants count group by type. e.g. SNP, INDEL, MNP, SNV, ...
        :type variantTypeCounts: dict[str, int]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
